'   sdspi:  SPI interface to a Secure Digital card.
'
'   initial version: Copyright 2008   Radical Eye Software
'
'   SDHC extensions (c)2010 Andy Schenk, Insonix.ch
'
'   See end of file for terms of use.
'
con
   sectorsize = 512
   sectorshift = 9

dat
cog     long 0
command long 0
param   long 0
blockno long 0

pub stop
   if cog
      cogstop(cog~ - 1)      

pub start(basepin)
'
' baspin is the first of 4 SD pins, or a long with the 4 pins in the 4 bytes.
'
   ifnot cog
     if basepin>>8==0
       start_explicit(basepin, basepin+1, basepin+2, basepin+3)
     else
       start_explicit(basepin&63, basepin>>8&63, basepin>>16&63, basepin>>24)
  return @entry

pub start_explicit(sdo, sclk, sdi, scs) : card_type | resp
'
'   Initialize the card!  Send a whole bunch of
'   clocks (in case the previous program crashed
'   in the middle of a read command or something),
'   then a reset command, and then wait until the
'   card goes idle.
'
  do := sdo
  clk := sclk 
  di := sdi
  cs := scs
  stop
  command := "I"
  cog := 1 + cognew(@entry, @command)
  repeat while command 
  if param < 0
    abort param
  return @entry

pub readblock(n, b)
'
'   Read a single block.  The "n" passed in is the
'   block number (blocks are 512 bytes); the b passed
'   in is the address of 512 blocks to fill with the
'   data.
'                              \
   param := b
   blockno := n
   command := "R"
   repeat while command
   if param
      abort param
   return 0
{
pub writeblock(n, b)
'
'   Write a single block.  Mirrors the read above.
'
   param := b
   blockno := n
   command := "W"
   repeat while command
   if param
      abort param
   return 0
}
pub release     'dummy

dat 
        org 
entry   mov comptr,par
        mov parptr,par
        add parptr,#4
        mov parptr2,parptr
        add parptr2,#4
        mov blocksh,#0
' set up
        mov acca,#1
        shl acca,di
        or dira,acca
        mov acca,#1
        shl acca,clk
        or dira,acca
        mov acca,#1
        shl acca,do
        mov domask,acca
        mov acca,#1
        shl acca,cs
        or dira,acca
        mov csmask,acca
        neg phsb,#1
        mov frqb,#0
        mov acca,nco
        add acca,clk
        mov ctra,acca
        mov acca,nco
        add acca,di
        mov ctrb,acca
        mov ctr2,onek
oneloop
        call #sendiohi
        djnz ctr2,#oneloop
        mov starttime,cnt
         mov ctr2,#9
reslp   mov cmdo,#0
        mov cmdp,#0
        call #cmd
         cmp accb,#1  wz
  if_z   jmp #tsthc
'         test accb,#4 wz
'         mov cmdo,#12          'reset multiblock
'  if_nz  call #cmd
         djnz ctr2,#reslp
tsthc    mov cmdo,#8           'test if SD2
         mov cmdp,#$1AA
         call #cmd
         cmp accb,#1  wz
  if_nz  jmp #resok            '< no
         mov ctr,#32
         call #sendiocnt       'read volt
         
inilp    mov cmdo,#55
         mov cmdp,#0
         call #cmd
         mov cmdo,#41
         mov cmdp,bit30
         call #cmd
         cmp accb,#0  wz
   if_nz jmp #inilp
         mov cmdo,#58         'test if SDHC
         mov cmdp,#0
         call #cmd
         mov ctr,#32
         call #sendiocnt
         or outa,csmask
         test accb,bit30  wz
   if_z  mov blocksh,#9      
         jmp #finished-1
resok   or outa,csmask
        call #sendiohi
initloop
        mov cmdo,#55
        call #cmd
        mov cmdo,#41
        call #cmd
        cmp accb,#1 wz
   if_z jmp #initloop
        mov blocksh,#9
'        wrlong accb,parptr           
        wrlong blocksh,parptr  '0=SDHC 9=SD
' reset frqa and the clock
finished
        mov frqa,#0
        wrlong frqa,comptr
        or outa,csmask
        neg phsb,#1
        call #sendiohi
pause
        mov acca,#511
        add acca,cnt
        waitcnt acca,#0
waitloop
        mov starttime,cnt
        rdlong acca,comptr wz
        cmp acca,#"B" wz
   if_z jmp #byteio
        mov ctr2,sector
'        cmp acca,#"W" wz
'   if_z jmp #wblock
        neg bufad,#128
'        cmp acca,#"E" wz
'   if_z jmp #eblocks
'        mov bufad,#0
'        cmp acca,#"G" wz
'   if_z jmp #eblocks
        cmp acca,#"R" wz
  if_nz jmp #pause
        rdlong bufad,parptr
        rdlong blocknr,parptr2
        call #rblock
        jmp  #finished
{
wblock
        mov starttime,cnt
        mov cmdo,#24
        rdlong cmdp,parptr2
        call #cmd
        mov phsb,#$fe
        call #sendio
        rdlong accb,parptr
        neg frqa,#1
wbyte
        rdbyte phsb,accb
        shl phsb,#23
        add accb,#1
        mov ctr,#8
wbit    mov phsa,#8
        shl phsb,#1
        djnz ctr,#wbit
        djnz ctr2,#wbyte        
        neg phsb,#1
        call #sendiohi
        call #sendiohi
        call #readresp
        and accb,#$1f
        sub accb,#5
        wrlong accb,parptr
        call #busy
        jmp #finished

eblocks
        rdlong blocknr,parptr2
        rdlong binsize,parptr
        mov    spincog,binsize
        and    binsize,memmsk
        mov    blocksz,binsize
        shr    spincog,#24
        shr    blocksz,#9
        add    blocksz,#1
        cogid  thiscog
        cogstop spincog
:loop   call   #rblock         'Read blocks to Mem 0..
        mov frqa,#0
        or outa,csmask
        neg phsb,#1
        call #sendiohi
        mov acca,#511
        add acca,cnt
        waitcnt acca,#0
        mov starttime,cnt
        mov ctr2,sector
        add    blocknr,#1
        add    bufad,sector
        djnz   blocksz,#:loop
        mov    bufad,binsize   'clear to end of memory
:clrm   wrlong blocksz,bufad
        add    bufad,#4
        cmp    bufad,memend  wc
   if_b jmp    #:clrm
        or     spin_vm,spincog        
        coginit spin_vm        'start Spin new in same cog
        cogstop thiscog        
:halt   jmp    #:halt
}         
rblock
        mov starttime,cnt
        mov cmdo,#17
'        rdlong cmdp,parptr2
        mov  cmdp,blocknr
        call #cmd
        call #readresp
'        rdlong accb,parptr
        mov accb,bufad
        sub accb,#1
rbyte
        mov phsa,hifreq
        mov frqa,freq
        add accb,#1
        test domask,ina wc
        addx acca,acca
        test domask,ina wc
        addx acca,acca
        test domask,ina wc
        addx acca,acca
        test domask,ina wc
        addx acca,acca
        test domask,ina wc
        addx acca,acca
        test domask,ina wc
        addx acca,acca
        test domask,ina wc
        addx acca,acca
        mov frqa,#0
        test domask,ina wc
        addx acca,acca
        mov  accb,accb   wc   'addr >=0 ?
  if_nc wrbyte acca,accb
        djnz ctr2,#rbyte        
        mov frqa,#0
        neg phsb,#1
        call #sendiohi
        call #sendiohi
        or outa,csmask
        wrlong ctr2,parptr
'        jmp #finished
rblock_ret  ret

byteio     
        rdlong phsb,parptr
        call #sendio
        wrlong accb,parptr
        jmp #finished
sendio
        rol phsb,#24
sendiohi
        mov ctr,#8
sendiocnt
        neg frqa,#1
        mov accb,#0
bit     mov phsa,#8
        test domask,ina wc
        addx accb,accb        
        rol phsb,#1
        djnz ctr,#bit
sendio_ret
sendiohi_ret
sendiocnt_ret
        ret
checktime
        mov duration,cnt
        sub duration,starttime
        cmp duration,clockfreq wc
checktime_ret
  if_c  ret
        neg duration,#13
        wrlong duration,parptr
        jmp #finished
cmd
         cmp cmdo,#41  wz
  if_z   or outa,csmask
         nop
        andn outa,csmask
        neg phsb,#1
        call #sendiohi
        mov phsb,cmdo
        add phsb,#$40
        call #sendio
        mov phsb,cmdp
        shl phsb,blocksh
        call #sendiohi
        call #sendiohi
        call #sendiohi
        call #sendiohi
        cmp cmdo,#8  wz
  if_z  mov phsb,#$87
  if_nz mov phsb,#$95
        call #sendio
        cmp cmdo,#12 wz
  if_z  neg phsb,#1
  if_z  call #sendiohi
readresp
        neg phsb,#1
        call #sendiohi
        call #checktime
        cmp accb,#$ff wz
   if_z jmp #readresp 
cmd_ret
readresp_ret
        ret
busy
        neg phsb,#1
        call #sendiohi
        call #checktime
        cmp accb,#$0 wz
   if_z jmp #busy
busy_ret
        ret

di      long 0
do      long 0
clk     long 0
cs      long 0
nco     long $1000_0000
hifreq  long $e0_00_00_00
freq    long $20_00_00_00
clockfreq long 80_000_000
onek    long 1000
sector  long 512
spin_vm long ($0004 << 16) | ($F004 << 2) | 0
memend  long $7F7F
memmsk  long $00FFFFFF
bit30   long 1<<30

domask  res 1
csmask  res 1
acca    res 1
accb    res 1
cmdo    res 1
cmdp    res 1
comptr  res 1
parptr  res 1
parptr2 res 1
ctr     res 1
ctr2    res 1
starttime res 1
duration res 1

bufad    res 1
blocknr  res 1
blocksz  res 1
blocksh  res 1
binsize  res 1
clkrg    res 1
thiscog  res 1
spincog  res 1  

extra_buf     long      0[256 - ((@extra_buf - @entry) >> 2) #> 0]  'Pad buffer to 1024 bytes

{{
'  Permission is hereby granted, free of charge, to any person obtaining
'  a copy of this software and associated documentation files
'  (the "Software"), to deal in the Software without restriction,
'  including without limitation the rights to use, copy, modify, merge,
'  publish, distribute, sublicense, and/or sell copies of the Software,
'  and to permit persons to whom the Software is furnished to do so,
'  subject to the following conditions:
'
'  The above copyright notice and this permission notice shall be included
'  in all copies or substantial portions of the Software.
'
'  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
'  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
'  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
'  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
'  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
'  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
'  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
}}